
%clearvars 

%DTdata=load('Kalibrert_USB_Trykk_16_22_59_26562500.dat');         %velg driftspunkt
%importer filer
clearvars -except ampl
load('RunnerMat.mat') %{42 50 75}

Col=[1 2 3 4 5 6 7];
c=[1 2 3 4 5 6 7];
nsamples=22199;
ncolumns=7;
tr=3;  %velger transduser
OP=2;   %velger driftspunkt 1=42, 2=50, 3=75
HP=377;

for i=1:nsamples
    for k=1:ncolumns 
        rmat(i,k)=mat{1,OP}(i,k);            %velge driftspunkt
    end
end
temp2D(1:nsamples,1:7)=rmat(1:nsamples,c);


%% kalibreringsverdier
mat=rmat;
for k=1:nsamples
    temp2D(:,1)=mat(:,1);
    temp2D(:,2)=(mat(:,2).*0.00000104+0.042).*100;
    temp2D(:,3)=(mat(:,3).*0.00000104+0.0373).*100;
    temp2D(:,4)=(mat(:,4).*0.00000104+0.0328).*100;
    temp2D(:,5)=(mat(:,5).*0.00000104+0.0413).*100;
    temp2D(:,6)=(mat(:,6).*0.00000104+0.0352).*100;
    temp2D(:,7)=(mat(:,7).*0.00000104+0.0466).*100;
   
end

%%
%Normaliserer
for i=1:ncolumns
    temp2D_rms(:,i)=temp2D(:,i)-rms(temp2D(:,i));
end



Fs=1613;
nfft=nsamples;
L=floor(nfft/2+1);


pwelchArray2D=zeros(L,3);
pwelchArray3D=zeros(L,3,ncolumns);
y=zeros(L,1);
T=(0:1:nfft-1)/Fs;

window_weight=(L/2);
overlapPercent=70;

for i=1:ncolumns
    [pxx,f] = pwelch(temp2D_rms(:,i), hanning(window_weight),overlapPercent, nfft,Fs);

   
    for j=1:L
     y(j)=Col(:,i);
     
    end
 
 pwelchArray2D=[f y pxx];
 pwelchArray3D(:,:,i)=(pwelchArray2D);

end

g=pwelchArray3D(:,1,tr);     
h=pwelchArray3D(:,3,tr);    

%normaliserer
for i=1:ncolumns
    temp2D(:,i)=temp2D(:,i)./HP;
end

%% plotter
Fig=figure('Color',[1 1 1]);

box('on');hold('all');
dcm_obj = datacursormode(Fig);
%set(dcm_obj,'UpdateFcn',@display_data,'DisplayStyle','datatip','SnapToDataVertex','off','Enable','on');
%set(gca,'YTickLabel', {});%,'YTick',[]);
grid on

stem(g/6.25,h/HP,'Marker','none','Color',1/255*[0 0 255]);
xlabel ('Frequency [-]','FontSize',12,'FontName','Calibri');
ylabel ('Amplitude [-]','FontSize',12,'FontName','Calibri');
title('Prototype 50% load','FontSize',14,'FontName','Calibri');
xlim([0,30])


figure2 = figure('Color',[1 1 1]);                     % Plot raw data

box('on');  hold('all'); %ylim([98.9 99.2]);grid('on');
plot(temp2D(:,1),temp2D(:,tr));
plot(T,temp2D(:,tr),'Color',1/255*[0 0 255]); 
plot(T,mean(temp2D(:,tr)),'-r');
xlabel ('Time [S]','FontSize',12,'FontName','Calibri');
ylabel ('Pressure [-]','FontSize',12,'FontName','Calibri');
title('Prototype 50% load','FontSize',14,'FontName','Calibri');
xlim([0,0.2]);

%%
%finner topp- og bunnpunkt
%sett begrensing p hvilke ekstempunkter som tas med
%plotter gjennomsnitt av ekstrempunkter og generell mean

trykk=temp2D(:,tr);

[pksThr,locsThr] = findpeaks(trykk,'minpeakdistance',9);%,'minpeakheight',2.8);

mintrykk=-1*trykk;
[pksThrmin,locsThrmin] = findpeaks(mintrykk,'minpeakdistance',9);%,'minpeakheight',-2.6);

figure(3)
plot(T,trykk, T(locsThr),pksThr,'rv','MarkerFaceColor','r');  hold on   
plot(T,trykk, T(locsThrmin),-pksThrmin,'rv','MarkerFaceColor','r');  hold on   
plot(T,mean(pksThr),'-r');
plot(T,-mean(pksThrmin),'-r');
plot(T,mean(trykk));
set(gcf,'color','w');
xlabel ('Time [S]','FontSize',12,'FontName','Calibri');
ylabel ('Pressure [-]','FontSize',12,'FontName','Calibri');
title('Time','FontSize',14,'FontName','Calibri');
xlim([0,0.5]);
%ylim([2,4]);


%%

%plotter scatter amplitude
last=[42 50 75];

amplitudeP= mean(pksThr)+mean(pksThrmin);
y=3;
load=last(1,OP);
zoom=1000;


figure(4)
scatter(load,y,zoom*amplitudeP,'filled','b'); hold on;

xlim([20,100]);
ylim([0,4]);

xlabel ('Load [%]','FontSize',12,'FontName','Calibri');
set(gca,'YTickLabel', {'Prototype/Model', 'Model', 'Prototype'}, 'YTick',[1 2 3]);
title('Comparison','FontSize',14,'FontName','Calibri')

ampl(1,OP)=amplitudeP;



%clearvars -except Runnermat amplitude pksThr pksThrmin ampl



