%% Tar inn data og velger kolonner som skal samples
clearvars -except cal data amplM
clc
load('caldata.mat');
Col=[1 2 3 4 5 6 7 8];
HM=35.45;

c=[1 2 3 10];       %stasjonr
d=[1 2 3];          %roterende
samp=2;             %antall samp. pluss 1
tr=2;               %velger hva man vil se p
op=3;               %velger driftspunkt
OPN=3;

temp2D(:,1:4)=data{op,1}(:,c);
temp2D(:,5:7)=data{op,samp}(:,d);  

ncolumns=7;
nsamples=29999;
exlim=30;           %setter xaksen

%% Normaliserer resultatene.

for i=1:ncolumns
    temp2D_rms(:,i)=temp2D(:,i)-rms(temp2D(:,i));
end



Fs=2000;
nfft=nsamples;
L=floor(nfft/2+1);

pwelchArray2D=zeros(L,3);
pwelchArray3D=zeros(L,3,ncolumns);
y=zeros(L,1);
T=(0:1:nfft-1)/Fs;


window_weight=(L/2);
overlapPercent=70;

for i=1:ncolumns
    [pxx,f] = pwelch(temp2D_rms(:,i), hanning(window_weight),overlapPercent, nfft,Fs);

    for j=1:L
     y(j)=Col(:,i);
     
    end
 
 pwelchArray2D=[f y pxx];
 pwelchArray3D(:,:,i)=(pwelchArray2D);

end

g=pwelchArray3D(:,1,tr);     
h=pwelchArray3D(:,3,tr);     


for i=1:ncolumns
    temp2D(:,i)=temp2D(:,i)./HM;
end
%% Plotter resultatene

Fig=figure('Color',[1 1 1]);

box('on');hold('all');
  xlim([0,exlim]);
  grid on
dcm_obj = datacursormode(Fig);
set(dcm_obj,'UpdateFcn',@display_data,'DisplayStyle','datatip','SnapToDataVertex','off','Enable','on')
stem(g./9,h./HM,'Marker','none','Color',1/255*[0 0 255]);
xlabel ('Frequency [-]','FontSize',12,'FontName','Calibri');
ylabel ('Amplitude [-]','FontSize',12,'FontName','Calibri');
title('Model 50% load','FontSize',14,'FontName','Calibri');
xlim([0,1.2])

figure2 = figure('Color',[1 1 1]);                                                                                            % Plot raw data
box('on');  hold('all');

plot(T,temp2D(:,tr),'Color',1/255*[0 0 255]); 
plot(T,mean(temp2D(:,tr)),'-r');
xlabel ('Time [S]','FontSize',12,'FontName','Calibri');
ylabel ('Pressure [-]','FontSize',12,'FontName','Calibri');
title('Model 50% load','FontSize',14,'FontName','Calibri')
xlim([0,5]);

%%
trykk=temp2D(:,tr);

[pksThrM,locsThrM] = findpeaks(trykk,'minpeakdistance',100);

mintrykk=-1*trykk;
[pksThrminM,locsThrminM] = findpeaks(mintrykk,'minpeakdistance',100);

figure(3)
plot(T,trykk, T(locsThrM),pksThrM,'rv','MarkerFaceColor','r');  hold on   
plot(T,trykk, T(locsThrminM),-pksThrminM,'rv','MarkerFaceColor','r');  hold on   
plot(T,mean(pksThrM),'-r');
plot(T,-mean(pksThrminM),'-r');
plot(T,mean(trykk));
set(gcf,'color','w');
xlim([0,5]);

%%
last=[42 50 75];

amplitudeM= mean(pksThrM)+mean(pksThrminM);
y=2;
load=last(1,OPN);
zoom=1000;

figure(4)
scatter(load,y,zoom*amplitudeM,'filled','b'); hold on;

xlim([20,100]);
ylim([0,4]);

xlabel ('Load [%]','FontSize',12,'FontName','Calibri');
set(gca,'YTickLabel', {'Prototype/Model', 'Model', 'Prototype'}, 'YTick',[1 2 3]);
title('Comparison','FontSize',14,'FontName','Calibri')

amplM(1,OPN)=amplitudeM;

%clearvars -except amplM

