%% Calibration of raw data

clearvars -except cal  

ind_samples=1;

mappe= uigetdir;
filepattern=strcat(mappe,'\*.xlsx');
% filepattern=fullfile('M:','MATLAB','Resultat','*.xlsx');
xlsxfiles=dir(filepattern);
length=(length(xlsxfiles))/(2*ind_samples)-2;   %Number of samples (divided by two since results from the RIOs are saved in separate files. 

nsamples=29999;
ncolumns1=12;
ncolumns2=11;
p=104.816152;

%% Calibration stasjonre mlinger 
 
for k=1:length
    for h=1:ind_samples
        data{k,h}(:,1)= cal{k,h}(:,1)*10.1;
        data{k,h}(:,2)= cal{k,h}(:,2)*10;
        data{k,h}(:,3)= cal{k,h}(:,3)*10;
        data{k,h}(:,4)= (cal{k,h}(:,4)*488.34575988)-197.79087116;
        data{k,h}(:,5)= (cal{k,h}(:,5)*124.99731727)-147.56618266;
        data{k,h}(:,6)= (cal{k,h}(:,6)*125.07688471)-148.91611524;
        data{k,h}(:,7)= (cal{k,h}(:,7)*(31.247519))-62.4527;
        
        for j=1:nsamples
            if cal{k,h}(j,8) <= 1
                data{k,h}(j,8)= 0;
            else
                data{k,h}(j,8)= 1;
            end
        end
    
            
            
            data{k,h}(:,9)= (cal{k,h}(:,9).*(-70.31068838*1000))+13.46620876;
            data{k,h}(:,10)= (cal{k,h}(:,10).*(-154.91703928*1000))+54.48242625;
            data{k,h}(:,11)= (cal{k,h}(:,11).*(-140.82223184*1000))+99.64090291;
            data{k,h}(:,12)= (cal{k,h}(:,12)).*1e-6;
            
  
  %% Calibration roterende mlinger          
            
            for j=1:nsamples
                if cal{k,h+ind_samples}(j,1) <= 1
                    data{k,h+ind_samples}(j,1)= 0;
                else
                    data{k,h+ind_samples}(j,1)= 1;
                end
            end
            
            
            data{k,h+ind_samples}(:,2)= (cal{k,h+ind_samples}(:,2).*(33974.0739))-100.5264+p;
            data{k,h+ind_samples}(:,3)= (cal{k,h+ind_samples}(:,3).*1e-6);
            
            
%             data{k,h+ind_samples}(:,2)= (cal{k,h+ind_samples}(:,2).*(34194.785))-97.5116+p;
%             data{k,h+ind_samples}(:,3)= (cal{k,h+ind_samples}(:,3).*(34501.0394))-106.5909+p;
%             data{k,h+ind_samples}(:,4)= (cal{k,h+ind_samples}(:,4).*(34113.1243))-109.4301+p;
%             data{k,h+ind_samples}(:,5)= (cal{k,h+ind_samples}(:,5).*(34388.0562))-97.4117+p;
%             data{k,h+ind_samples}(:,6)= (cal{k,h+ind_samples}(:,6).*(33974.0739))-100.5264+p;
%             data{k,h+ind_samples}(:,7)= (cal{k,h+ind_samples}(:,7).*(34292.9657))-101.5059+p;
%             data{k,h+ind_samples}(:,8)= (cal{k,h+ind_samples}(:,8).*(34175.6596))-97.1283+p;
%             data{k,h+ind_samples}(:,9)= (cal{k,h+ind_samples}(:,9).*(34078.753))-108.9612+p;
%             data{k,h+ind_samples}(:,10)= (cal{k,h+ind_samples}(:,10).*(34180.686))-92.9927+p;
%             data{k,h+ind_samples}(:,11)= (cal{k,h+ind_samples}(:,11).*1e-6);
            
        end
    end


    
clearvars -except cal data
save('caldata')
